# coding: utf-8

# Copyright 2011 Robert Siemer <Robert.Siemer-anki@backsla.sh>

# This file is part of “Panki Chinese”.

# “Panki Chinese” is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# “Panki Chinese” is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with “Panki Chinese”.  If not, see <http://www.gnu.org/licenses/>.


# Access card history from card templates: allows JavaScript to create dynamic cards

# panki chinese history dynamic cards

# This plugin is part of “Panki Chinese”. It requires cache-less (q/a cache)
# operation and some other minor tweaks to have any effect.
# Both requirements are fulfilled by using the “Panki Chinese” main plugin,
# which has other secondary effects (see main plugin).

# Once working, card history can placed in the card template via:
# <span id='data' {{#cardHistory}}
#  data-reps='{{reps}}'
#  data-interval='{{interval}}'
#  data-successive='{{successive}}'
# {{/cardHistory}} ></span>

# and accessed via JavaScript within the card.

import anki.hooks, collections

class AttrToItem(collections.Mapping):
    def __init__(self, instance):
        self.instance = instance
    def __len__(self):
        return 1
    def __iter__(self):
        return iter([self])
    def __getitem__(self, key):
        return getattr(self.instance, key)

def fieldEnhancer(fields, *args, **kwargs):
    if 'card' in kwargs:
        fields['cardHistory'] = AttrToItem(kwargs['card'])
    return fields

anki.hooks.addHook('prepareFields', fieldEnhancer)
